<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_AvailResponseRS StructType
 * @subpackage Structs
 */
class JP_AvailResponseRS extends AbstractStructBase
{
    /**
     * The Errors
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_ErrorType
     */
    public $Errors;
    /**
     * The Warnings
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Warnings
     */
    public $Warnings;
    /**
     * The ExtraInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ExtraInfo;
    /**
     * The Results
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Results
     */
    public $Results;
    /**
     * The OptionalDescriptions
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_OptionalDescriptions
     */
    public $OptionalDescriptions;
    /**
     * The ProcessingTime
     * @var string
     */
    public $ProcessingTime;
    /**
     * The Url
     * @var string
     */
    public $Url;
    /**
     * The TimeStamp
     * @var string
     */
    public $TimeStamp;
    /**
     * The IntCode
     * @var string
     */
    public $IntCode;
    /**
     * Constructor method for JP_AvailResponseRS
     * @uses JP_AvailResponseRS::setErrors()
     * @uses JP_AvailResponseRS::setWarnings()
     * @uses JP_AvailResponseRS::setExtraInfo()
     * @uses JP_AvailResponseRS::setResults()
     * @uses JP_AvailResponseRS::setOptionalDescriptions()
     * @uses JP_AvailResponseRS::setProcessingTime()
     * @uses JP_AvailResponseRS::setUrl()
     * @uses JP_AvailResponseRS::setTimeStamp()
     * @uses JP_AvailResponseRS::setIntCode()
     * @param \ArrayType\ArrayOfJP_ErrorType $errors
     * @param \StructType\JP_Warnings $warnings
     * @param string $extraInfo
     * @param \StructType\JP_Results $results
     * @param \StructType\JP_OptionalDescriptions $optionalDescriptions
     * @param string $processingTime
     * @param string $url
     * @param string $timeStamp
     * @param string $intCode
     */
    public function __construct(\ArrayType\ArrayOfJP_ErrorType $errors = null, \StructType\JP_Warnings $warnings = null, $extraInfo = null, \StructType\JP_Results $results = null, \StructType\JP_OptionalDescriptions $optionalDescriptions = null, $processingTime = null, $url = null, $timeStamp = null, $intCode = null)
    {
        $this
            ->setErrors($errors)
            ->setWarnings($warnings)
            ->setExtraInfo($extraInfo)
            ->setResults($results)
            ->setOptionalDescriptions($optionalDescriptions)
            ->setProcessingTime($processingTime)
            ->setUrl($url)
            ->setTimeStamp($timeStamp)
            ->setIntCode($intCode);
    }
    /**
     * Get Errors value
     * @return \ArrayType\ArrayOfJP_ErrorType|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \ArrayType\ArrayOfJP_ErrorType $errors
     * @return \StructType\JP_AvailResponseRS
     */
    public function setErrors(\ArrayType\ArrayOfJP_ErrorType $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Get Warnings value
     * @return \StructType\JP_Warnings|null
     */
    public function getWarnings()
    {
        return $this->Warnings;
    }
    /**
     * Set Warnings value
     * @param \StructType\JP_Warnings $warnings
     * @return \StructType\JP_AvailResponseRS
     */
    public function setWarnings(\StructType\JP_Warnings $warnings = null)
    {
        $this->Warnings = $warnings;
        return $this;
    }
    /**
     * Get ExtraInfo value
     * @return string|null
     */
    public function getExtraInfo()
    {
        return $this->ExtraInfo;
    }
    /**
     * Set ExtraInfo value
     * @param string $extraInfo
     * @return \StructType\JP_AvailResponseRS
     */
    public function setExtraInfo($extraInfo = null)
    {
        // validation for constraint: string
        if (!is_null($extraInfo) && !is_string($extraInfo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($extraInfo)), __LINE__);
        }
        $this->ExtraInfo = $extraInfo;
        return $this;
    }
    /**
     * Get Results value
     * @return \StructType\JP_Results|null
     */
    public function getResults()
    {
        return $this->Results;
    }
    /**
     * Set Results value
     * @param \StructType\JP_Results $results
     * @return \StructType\JP_AvailResponseRS
     */
    public function setResults(\StructType\JP_Results $results = null)
    {
        $this->Results = $results;
        return $this;
    }
    /**
     * Get OptionalDescriptions value
     * @return \StructType\JP_OptionalDescriptions|null
     */
    public function getOptionalDescriptions()
    {
        return $this->OptionalDescriptions;
    }
    /**
     * Set OptionalDescriptions value
     * @param \StructType\JP_OptionalDescriptions $optionalDescriptions
     * @return \StructType\JP_AvailResponseRS
     */
    public function setOptionalDescriptions(\StructType\JP_OptionalDescriptions $optionalDescriptions = null)
    {
        $this->OptionalDescriptions = $optionalDescriptions;
        return $this;
    }
    /**
     * Get ProcessingTime value
     * @return string|null
     */
    public function getProcessingTime()
    {
        return $this->ProcessingTime;
    }
    /**
     * Set ProcessingTime value
     * @param string $processingTime
     * @return \StructType\JP_AvailResponseRS
     */
    public function setProcessingTime($processingTime = null)
    {
        // validation for constraint: string
        if (!is_null($processingTime) && !is_string($processingTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($processingTime)), __LINE__);
        }
        $this->ProcessingTime = $processingTime;
        return $this;
    }
    /**
     * Get Url value
     * @return string|null
     */
    public function getUrl()
    {
        return $this->Url;
    }
    /**
     * Set Url value
     * @param string $url
     * @return \StructType\JP_AvailResponseRS
     */
    public function setUrl($url = null)
    {
        // validation for constraint: string
        if (!is_null($url) && !is_string($url)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($url)), __LINE__);
        }
        $this->Url = $url;
        return $this;
    }
    /**
     * Get TimeStamp value
     * @return string|null
     */
    public function getTimeStamp()
    {
        return $this->TimeStamp;
    }
    /**
     * Set TimeStamp value
     * @param string $timeStamp
     * @return \StructType\JP_AvailResponseRS
     */
    public function setTimeStamp($timeStamp = null)
    {
        // validation for constraint: string
        if (!is_null($timeStamp) && !is_string($timeStamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($timeStamp)), __LINE__);
        }
        $this->TimeStamp = $timeStamp;
        return $this;
    }
    /**
     * Get IntCode value
     * @return string|null
     */
    public function getIntCode()
    {
        return $this->IntCode;
    }
    /**
     * Set IntCode value
     * @param string $intCode
     * @return \StructType\JP_AvailResponseRS
     */
    public function setIntCode($intCode = null)
    {
        // validation for constraint: string
        if (!is_null($intCode) && !is_string($intCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($intCode)), __LINE__);
        }
        $this->IntCode = $intCode;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_AvailResponseRS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
